
///////////////////////////////////////////////////////////////////////////////
//
//	bananas.h
//

#ifndef _BANANAS_
#define _BANANAS_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"


class ProjectManager;
class BananasManager;



//	oiiZbg̃f[^
//---------------------------------------------------------
struct BananaSetData{
	static const int BNSET_WIDTH=32, BNSET_HEIGHT=24;	// \łőTCY
	bool set[BNSET_WIDTH][BNSET_HEIGHT];				// oii̕ѕ
	int width, height;									// TCY
public:
	void load(const ProjectManager *project, BANK bank, SADRS adrs);
};



//	oiiǗ
//-------------------------------------------------------
class BananasManager : public RomData_Base{

private:
	int banana_set_count;
	LADRS pBananaSetAdrs;
	char (*banana_set_name)[256];
	BananaSetData *banana_set_data;
public:
	int get_banana_set_count();
	const char *get_banana_set_name(int banana_set_num);
	BananaSetData *get_banana_set_data(int banana_set_num);


private:
	ProjectManager *project;


public:
	BananasManager(ProjectManager *_project);
	~BananasManager();
	void load();

};




///////////////////////////////////////////////////////////////////////////////

#endif // _BANANAS_



