
////////////////////////////////////////////////////////////
//
//  pattern.cpp
//

#include "map_compresser.h"

using namespace RareCompresser;


PatternBuffer::PatternBuffer(){
    index = 0;
    count = 0;
}
PatternBuffer::~PatternBuffer(){
}

// p^[(1ڂ)
int PatternBuffer::search(const byte *src_sc, const byte **pointer){  // src_sc : 2ڂ̃|C^
    int length_max = 0;
    int index_max = -1;
    int i, j;
    if (count == 0){
        return -1;      // ܂1ڂoĂĂȂƂ́A_O(1𑫂0ɂȂ)
    }
    // p^[́AȂׂŋ߂̂̂猟B(Rs[R}hg\߂邽)
    i = index!=0 ? index-1 : PTN_MAX-1;
    while (i!=index){
        // v`FbN[v([v𔲂_j̒lv)
        for (j=0; j<PatternElement::PTN_SIZE; j++){
            if (elem[i].pattern[j] != src_sc[j]) break;
        }
        // L^XVǂ
        if (j > length_max){
            length_max = j;
            index_max = i;
        }
        if (i==0){
            if (count == PTN_MAX) i=PTN_MAX-1;  // 2ڈȍ~̏ꍇ, [v
            else break;                         // ܂1ڂ̏ꍇAŏI
        }else{
            i--;
        }
    }
    if (length_max){
        *pointer = elem[index_max].ptr;
    }
    return length_max;
}

// p^[ǉ
void PatternBuffer::add(const byte *src_pr){    // src_pr : 1ڂ̃|C^
    memcpy(elem[index].pattern, src_pr+1, PatternElement::PTN_SIZE);    // 2ڂRs[
    elem[index].ptr = src_pr;   // 1ڂ̃|C^Zbg
    if (++index == PTN_MAX) index = 0;
    if (count != PTN_MAX) count++;
    return;
}


////////////////////////////////////////////////////////////////////////////////


// p^[
int PatternManager::search(const byte *src, const byte **pointer){
    int length = buffers[*src].search(src+1, pointer);
    return length + 1;
}

// p^[ǉ
void PatternManager::add(const byte *src){
    buffers[*src].add(src);
    return;
}








