
///////////////////////////////////////////////////////////////////////////////
//
//	platinum_def.h
//

#ifndef _PLATINUM_DEF_
#define _PLATINUM_DEF_


#include <windows.h>


//	FMFwb_[
//---------------------------------------------------------
typedef struct _FMFHeader{
	DWORD identifier;
    DWORD size;
    DWORD map_width;
    DWORD map_height;
    BYTE chip_width;
    BYTE chip_height;
    BYTE layer_count;
    BYTE bit_count;
} FMFHeader;


#define MAKE_IDENTIFIER(ch0, ch1, ch2, ch3)                              \
                ((DWORD)(BYTE)(ch0) | ((DWORD)(BYTE)(ch1) << 8) |   \
                ((DWORD)(BYTE)(ch2) << 16) | ((DWORD)(BYTE)(ch3) << 24 ))



typedef struct _UMFHeader{
	LONG map_width;
	LONG map_height;
	LONG chip_width;
	LONG chip_height;
	BYTE layer_count;
	BYTE bit_count;
	BYTE relative_path;
	BYTE reserved;
} UMFHeader;



#endif // _PLATINUM_DEF_


#ifndef _MSC_VER
#define strcpy_s(buf, buf_size, src) strcpy(buf, src)
#endif



