
///////////////////////////////////////////////////////////////////////////////
//
//	undo.h
//

#ifndef _UNDO_
#define _UNDO_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>


//---------------------------------------------------------
class UndoMethod{
public:

	virtual ~UndoMethod(){}
	virtual void undo()=0;
	virtual void redo()=0;
	virtual LPCSTR text_undo() const=0;
	virtual LPCSTR text_redo() const=0;

};





///////////////////////////////////////////////////////////////////////////////

#endif // _UNDO_



