
///////////////////////////////////////////////////////////////////////////////
//
//	char.h
//

#ifndef _CHAR_
#define _CHAR_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"


class ProjectManager;



class CharacterManager : public RomData_Base{

	ProjectManager *project;
	char shift_jis[256][4];

public:
	CharacterManager(ProjectManager *_project);
	~CharacterManager();

	int to_shift_jis(char *buf, BYTE src[], size_t src_size);
	int from_shift_jis(const char *src, BYTE buf[], size_t buf_size);

};


///////////////////////////////////////////////////////////////////////////////

#endif // _CHAR_


