
///////////////////////////////////////////////////////////////////////////////
//
//	id.h
//

#ifndef _ID_
#define _ID_

///////////////////////////////////////////////////////////////////////////////


//	ACR\[XID
//---------------------------------------------------------
#define IDI_SDK2ED			0x0101
#define IDI_PAN_HORZ		0x0111
#define IDI_PAN_VERT		0x0112
#define IDI_PAN_BOTH		0x0113


//	rbg}bv\[XID
//---------------------------------------------------------
#define IDB_TOOLIMG			0x0201
#define IDB_BANANA			0x0202


//	XgOID
//---------------------------------------------------------
#define IDS_FILE_OPEN		0x0801
#define IDS_FILE_SAVE		0x0802
#define IDS_EDIT_UNDO		0x0811
#define IDS_EDIT_REDO		0x0812
#define IDS_VIEW_TILEMAP	0x0821
#define IDS_VIEW_SPRITES	0x0822
#define IDS_VIEW_BANANAS	0x0823
#define IDS_VIEW_CAMERAS	0x0824
#define IDS_LEVEL_SELECT	0x0831
#define IDS_LEVEL_SETTING	0x0832
#define IDS_MAP_TILEMAP		0x0841
#define IDS_FILE_TESTPLAY	0x0803


//	j[ACeER}hID
//---------------------------------------------------------
#define IDM_FILE_OPEN		0x1101
#define IDM_FILE_RECENT_BEGIN		0x1141
#define IDM_FILE_RECENT_CLEAR		0x117F
#define IDM_FILE_SAVE		0x1102
#define IDM_FILE_SAVEAS		0x1103
#define IDM_FILE_RELOAD		0x1104
#define IDM_FILE_CLOSE		0x1105
#define IDM_FILE_TESTPLAY	0x1106
#define IDM_FILE_SETEMU		0x1107
#define IDM_FILE_QUIT		0x110F

#define IDM_EDIT_UNDO		0x1201
#define IDM_EDIT_REDO		0x1202

#define IDM_VIEW_TOOL		0x1301
#define IDM_VIEW_STATUS		0x1302
#define IDM_VIEW_TILEMAP	0x1311
#define IDM_VIEW_TILEMAP_I	0x1312
#define IDM_VIEW_MAP_HIDE		0x1314
#define IDM_VIEW_MAP_TILEMAP	0x1315
#define IDM_VIEW_MAP_ACTION		0x1316
#define IDM_VIEW_SPRITES	0x1321
#define IDM_VIEW_SPRITES_I	0x1322
#define IDM_VIEW_SPR_HIDE		0x1324
#define IDM_VIEW_SPR_NORMAL		0x1325
#define IDM_VIEW_SPR_SIMPLE		0x1326
#define IDM_VIEW_BANANAS	0x1331
#define IDM_VIEW_BANANAS_I	0x1332
#define IDM_VIEW_BAN_HIDE		0x1334
#define IDM_VIEW_BAN_NORMAL		0x1335
#define IDM_VIEW_BAN_SIMPLE		0x1336
#define IDM_VIEW_CAMERAS	0x1341

#define IDM_LEVEL_SELECT	0x1401
#define IDM_LEVEL_RECENT_BEGIN	0x1441
#define IDM_LEVEL_RECENT_CLEAR	0x147F
#define IDM_LEVEL_SETTING	0x1402
#define IDM_LEVEL_ISDEDIT	0x1403
#define IDM_LEVEL_WLDCOMP	0x1404

#define IDM_MAP_TILEMAP		0x1501
#define IDM_MAP_MAPEDIT		0x1502

#define IDM_SPRITE_FINDSPR	0x1601
#define IDM_SPRITE_EDITSPR	0x1602

#define IDM_SPEECH_GENERAL		0x1701
#define IDM_SPEECH_SELECTION	0x1702


//	Rg[ID
//---------------------------------------------------------
#define IDC_STATIC0			0x4100
#define IDC_STATIC1			0x4101
#define IDC_STATIC2			0x4102
#define IDC_STATIC3			0x4103
#define IDC_STATIC4			0x4104
#define IDC_STATIC5			0x4105
#define IDC_STATIC6			0x4106
#define IDC_STATIC7			0x4107
#define IDC_STATIC8			0x4108
#define IDC_STATIC9			0x4109
#define IDC_STATICA			0x410A
#define IDC_STATICB			0x410B
#define IDC_STATICC			0x410C
#define IDC_STATICD			0x410D
#define IDC_STATICE			0x410E
#define IDC_STATICF			0x410F
#define IDC_STATIC10		0x4110
#define IDC_STATIC11		0x4111
#define IDC_STATIC12		0x4112
#define IDC_STATIC13		0x4113
#define IDC_STATIC14		0x4114
#define IDC_STATIC15		0x4115
#define IDC_STATIC16		0x4116
#define IDC_STATIC17		0x4117
#define IDC_STATIC18		0x4118
#define IDC_STATIC19		0x4119
#define IDC_STATIC1A		0x411A
#define IDC_STATIC1B		0x411B
#define IDC_STATIC1C		0x411C
#define IDC_STATIC1D		0x411D
#define IDC_STATIC1E		0x411E
#define IDC_STATIC1F		0x411F

#define IDC_EDIT0			0x4200
#define IDC_EDIT1			0x4201
#define IDC_EDIT2			0x4202
#define IDC_EDIT3			0x4203
#define IDC_EDIT4			0x4204
#define IDC_EDIT5			0x4205
#define IDC_EDIT6			0x4206
#define IDC_EDIT7			0x4207
#define IDC_EDIT8			0x4208
#define IDC_EDIT9			0x4209
#define IDC_EDITA			0x420A
#define IDC_EDITB			0x420B
#define IDC_EDITC			0x420C
#define IDC_EDITD			0x420D
#define IDC_EDITE			0x420E
#define IDC_EDITF			0x420F
#define IDC_EDIT10			0x4210
#define IDC_EDIT11			0x4211
#define IDC_EDIT12			0x4212
#define IDC_EDIT13			0x4213
#define IDC_EDIT14			0x4214
#define IDC_EDIT15			0x4215
#define IDC_EDIT16			0x4216
#define IDC_EDIT17			0x4217
#define IDC_EDIT18			0x4218
#define IDC_EDIT19			0x4219
#define IDC_EDIT1A			0x421A
#define IDC_EDIT1B			0x421B
#define IDC_EDIT1C			0x421C
#define IDC_EDIT1D			0x421D
#define IDC_EDIT1E			0x421E
#define IDC_EDIT1F			0x421F

#define IDC_BUTTON0			0x4300
#define IDC_BUTTON1			0x4301
#define IDC_BUTTON2			0x4302
#define IDC_BUTTON3			0x4303
#define IDC_BUTTON4			0x4304
#define IDC_BUTTON5			0x4305
#define IDC_BUTTON6			0x4306
#define IDC_BUTTON7			0x4307
#define IDC_BUTTON8			0x4308
#define IDC_BUTTON9			0x4309
#define IDC_BUTTONA			0x430A
#define IDC_BUTTONB			0x430B
#define IDC_BUTTONC			0x430C
#define IDC_BUTTOND			0x430D
#define IDC_BUTTONE			0x430E
#define IDC_BUTTONF			0x430F
#define IDC_BUTTON10		0x4310
#define IDC_BUTTON11		0x4311
#define IDC_BUTTON12		0x4312
#define IDC_BUTTON13		0x4313
#define IDC_BUTTON14		0x4314
#define IDC_BUTTON15		0x4315
#define IDC_BUTTON16		0x4316
#define IDC_BUTTON17		0x4317
#define IDC_BUTTON18		0x4318
#define IDC_BUTTON19		0x4319
#define IDC_BUTTON1A		0x431A
#define IDC_BUTTON1B		0x431B
#define IDC_BUTTON1C		0x431C
#define IDC_BUTTON1D		0x431D
#define IDC_BUTTON1E		0x431E
#define IDC_BUTTON1F		0x431F
#define IDC_BUTTON20		0x4320
#define IDC_BUTTON21		0x4321
#define IDC_BUTTON22		0x4322
#define IDC_BUTTON23		0x4323
#define IDC_BUTTON24		0x4324
#define IDC_BUTTON25		0x4325
#define IDC_BUTTON26		0x4326
#define IDC_BUTTON27		0x4327
#define IDC_BUTTON28		0x4328
#define IDC_BUTTON29		0x4329
#define IDC_BUTTON2A		0x432A
#define IDC_BUTTON2B		0x432B
#define IDC_BUTTON2C		0x432C
#define IDC_BUTTON2D		0x432D
#define IDC_BUTTON2E		0x432E
#define IDC_BUTTON2F		0x432F

#define IDC_CHECK0			0x4400
#define IDC_CHECK1			0x4401
#define IDC_CHECK2			0x4402
#define IDC_CHECK3			0x4403
#define IDC_CHECK4			0x4404
#define IDC_CHECK5			0x4405
#define IDC_CHECK6			0x4406
#define IDC_CHECK7			0x4407
#define IDC_CHECK8			0x4408
#define IDC_CHECK9			0x4409
#define IDC_CHECKA			0x440A
#define IDC_CHECKB			0x440B
#define IDC_CHECKC			0x440C
#define IDC_CHECKD			0x440D
#define IDC_CHECKE			0x440E
#define IDC_CHECKF			0x440F


#define IDC_LIST0			0x5110
#define IDC_LIST1			0x5111
#define IDC_LIST2			0x5112
#define IDC_LIST3			0x5113
#define IDC_LIST4			0x5114
#define IDC_LIST5			0x5115
#define IDC_LIST6			0x5116
#define IDC_LIST7			0x5117

#define IDC_COMBO0			0x5120
#define IDC_COMBO1			0x5121
#define IDC_COMBO2			0x5122
#define IDC_COMBO3			0x5123
#define IDC_COMBO4			0x5124
#define IDC_COMBO5			0x5125
#define IDC_COMBO6			0x5126
#define IDC_COMBO7			0x5127

#define IDC_TREE0			0x5130
#define IDC_TREE1			0x5131
#define IDC_TREE2			0x5132
#define IDC_TREE3			0x5133

#define IDC_TAB0			0x5140
#define IDC_TAB1			0x5141
#define IDC_TAB2			0x5142
#define IDC_TAB3			0x5143

#define IDC_STATUS0			0x5150
#define IDC_STATUS1			0x5151
#define IDC_STATUS2			0x5152
#define IDC_STATUS3			0x5153

#define IDC_TOOL0			0x5160
#define IDC_TOOL1			0x5161
#define IDC_TOOL2			0x5162
#define IDC_TOOL3			0x5163



///////////////////////////////////////////////////////////////////////////////

#endif // _ID_





