
///////////////////////////////////////////////////////////////////////////////
//
//	level_st_um.cpp
//

#include "project.h"


LevelSetting_UndoMethod::LevelSetting_UndoMethod(
	LevelManager *_level_manager,
	const LevelSettingData *_data_before,
	const LevelSettingData *_data_after,
	int _level_num
){
	level_manager	= _level_manager;
	data_before		= *_data_before;
	data_after		= *_data_after;
	level_num		= _level_num;
}

LevelSetting_UndoMethod::~LevelSetting_UndoMethod(){
}



void LevelSetting_UndoMethod::undo(){
	level_manager->setting = data_before;
	renew();
	return;
}
void LevelSetting_UndoMethod::redo(){
	level_manager->setting = data_after;
	renew();
	return;
}

void LevelSetting_UndoMethod::renew(){
	SADRS adrs_setting;
	// ROMobt@ɏ߂
	adrs_setting = level_manager->project->read_sadrs(0x3D, 2*level_num);
	level_manager->setting.store_data(level_manager->project, 0x3D, adrs_setting, level_manager->setting_max_size);
	// \̍XV
	if (level_num == level_manager->level_num){
		level_manager->redraw_all();
	}else{
		level_manager->level_num = level_num;
		level_manager->load_level();
	}
	return;
}




