
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_find.h
//

#ifndef _SPRITE_FIND_
#define _SPRITE_FIND_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"


class SpritesManager;
class ProjectManager;


//	FindsprManager: XvCg
//---------------------------------------------------------
class FindsprManager : public MyDialog, public RomData_Base{


private:

	ProjectManager *project;
	SpritesManager *sprites;

private:

	LPCSTR get_template() const{ return "SPRITE_FIND"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
	void init();
	void save_config();
	void sizing(WPARAM wParam, LPARAM lParam);
	void size(int width, int height);
	void sprite_sel();
	void type_changed();
	void find();
	void jump_sprite(int index);

public:
	FindsprManager(ProjectManager *_project, SpritesManager *_sprites);
	~FindsprManager();
	//BOOL create();
	BOOL command(WPARAM wParam, LPARAM lParam);
	BOOL translate_dialog_message(MSG *msg);
	void set_state(BOOL bEnabled);


};


///////////////////////////////////////////////////////////////////////////////

#endif // _SPRITE_FIND_



